/*
 * main.c
 */
#include"MSP430G2553.h"
#include"TCA6416A.h"

void WDT_init();
void I2C_IODect()	;		                 //¼ȷʵ

void main(void)
{
	WDTCTL = WDTPW + WDTHOLD;	//ع
    BCSCTL1 = CALBC1_16MHZ;      /* Set DCO to 8MHz */
    DCOCTL = CALDCO_16MHZ;
    TCA6416A_Init();			// ʼIOչ
//----ʾʼɹ----
	PinOUT(0,1);           // ָ0ŹܽΪ0
	PinOUT(1,0);           // ָ1ŹܽΪ0
	PinOUT(2,1);           // ָ0ŹܽΪ0
	PinOUT(3,0);           // ָ1ŹܽΪ0
	PinOUT(4,1);           // ָ0ŹܽΪ0
	PinOUT(5,0);           // ָ1ŹܽΪ0
	PinOUT(6,1);           // ָ0ŹܽΪ0
	PinOUT(7,0);           // ָ1ŹܽΪ0
	WDT_init();
	while(1)
	{
		PinIN();
		 I2C_IODect();
		 _bis_SR_register(LPM0_bits);
	}


}
/********WDTʼ**********/
void WDT_init()
{
	//-----趨WDTΪ-----------
	WDTCTL=WDT_ADLY_16;
	//-----WDTжʹ----------------------
    IE1 |= WDTIE;
}

/***********WDTʱжϺ*************/
#pragma vector=WDT_VECTOR
__interrupt void watchdog_timer(void)
{
//	PinIN();
//	 I2C_IODect();
__bic_SR_register_on_exit(LPM0_bits );
}
/**********I2CչIOж¼***************/
void I2C_IO10_Onclick()
{
	static unsigned char turn = 1;
	turn ^= BIT0;
	PinOUT(0,turn);         //ָ0ŹܽΪ0&1
	PinOUT(1,turn);         //ָ1ŹܽΪ0&1
}
void I2C_IO11_Onclick()
{
	static unsigned char turn = 1;
	turn ^= BIT0;
	PinOUT(2,turn);         //ָ2ŹܽΪ0&1
	PinOUT(3,turn);         //ָ3ŹܽΪ0&1
}
void I2C_IO12_Onclick()
{
	static unsigned char turn = 1;
	turn ^= BIT0;
	PinOUT(5,turn);         //ָ5ŹܽΪ0&1
	PinOUT(4,turn);         //ָ4ŹܽΪ0&1
}
void I2C_IO13_Onclick()
{
	static unsigned char turn = 1;
	turn ^= BIT0;
	PinOUT(6,turn);         //ָ6ŹܽΪ0&1
	PinOUT(7,turn);         //ָ7ŹܽΪ0&1
}
void I2C_IODect()			                 //¼ȷʵ
{
	static unsigned char KEY_Past=0,KEY_Now=0;
	KEY_Past=KEY_Now;
	//----жI2C_IO10KEY1Ƿ񱻰------
	if((TCA6416A_InputBuffer&BIT8) == BIT8)
		KEY_Now |=BIT0;
	else
		KEY_Now &=~BIT0;
	if(((KEY_Past&BIT0)==BIT0)&&(KEY_Now&BIT0) !=BIT0)
		I2C_IO10_Onclick();
	//----жI2C_IO11KEY2Ƿ񱻰------
	if((TCA6416A_InputBuffer&BIT9)== BIT9)
		KEY_Now |=BIT1;
	else
		KEY_Now &=~BIT1;
	if(((KEY_Past&BIT1)==BIT1)&&(KEY_Now&BIT1)!=BIT1)
		I2C_IO11_Onclick();
	//----жI2C_IO12KEY3Ƿ񱻰------
	if((TCA6416A_InputBuffer&BITA) == BITA)
		KEY_Now |=BIT2;
	else
		KEY_Now &=~BIT2;
	if(((KEY_Past&BIT2)==BIT2)&&(KEY_Now&BIT2) ==0)
	{
		I2C_IO12_Onclick();
	}
	//----жI2C_IO13KEY4Ƿ񱻰------
	if((TCA6416A_InputBuffer&BITB) ==  BITB)
		KEY_Now |=BIT3;
	else
		KEY_Now &=~BIT3;
	if(((KEY_Past&BIT3) == BIT3)&& (KEY_Now&BIT3) == 0)    //
	{
		I2C_IO13_Onclick();
	}
}
