/*
 * main.c
 */
#include "msp430g2553.h"
#include "TA_PWM.h"						//ǰдPWM⺯

#define	cSMCLK			12000000	// SMCLKΪ12MHz
#define	SIN_F				200				// ҲƵΪ200Hz
#define	SIN_NUM		32				// Ҳ
unsigned int table_Valu[64] = {0};	//ADC10

//----ұעSIN_NUM궨һ-----
//const unsigned int sin_table[SIN_NUM]={64,88,108,122,127,122,108,88,64,39,19,5,0,5,19,39};	//16ұ
//const unsigned int sin_table[SIN_NUM]={0,7,15,23,31,39,47,55,63,71,79,87,95,103,111,119};//16ݲ
//const unsigned int sin_table[SIN_NUM]={32,44,54,61,63,61,54,44,32,19,9,2,0,2,9,19};//16ֵұ
//const unsigned int sin_table[SIN_NUM]={0,10,20,30,40,50,60,70,80,90,100,110,120,110,100,90,80,70,60,50,40,30,20,10};//24ǲ
const unsigned int sin_table[SIN_NUM]={64,88,108,122,127,122,108,88,64,39,19,5,0,5,19,39	//һ߷ֵұһͷֵұ
		                                                              ,59,71,81,88,91,88,81,71,59,47,37,30,27,30,37,47};	//32㲻ȷұ
//const unsigned int sin_table[SIN_NUM]={127,127,127,127,127,127,127,127,0,0,0,0,0,0,0,0};	//16㷽


void  ADC10_WaveSample(unsigned char inch);
void Timer0_A_Init();
void Change_Duty();
void main(void)
{
	WDTCTL = WDTPW + WDTHOLD;                 // Stop WDT
	//-----DCOƵ趨Ϊ12MHz
	BCSCTL1 = CALBC1_12MHZ;          // Set range
	DCOCTL = CALDCO_12MHZ;         // Set DCO step + modulation
	DCOCTL = DCOCTL&0xE0;				//رջƵõƵ
    P1DIR |=BIT6;									//P1.6Ϊʾͬź
	//-----ʼTA1PWM-----
	TA1_PWM_Init('S',1,'F',0);		// TAʱΪACLK,ͨ1ǰPWMͨ2TA;
	TA1_PWM_SetPeriod(128);   // PWMΪ128ʱ
	//-----ADC10 ʼ-----
	ADC10CTL0 =SREF_1 + ADC10SHT_3 + REF2_5V + REFON+REFOUT + ADC10ON;
	ADC10CTL1 = INCH_0+CONSEQ_0;
	//=====ʱʼ=======
	Timer0_A_Init();
	_enable_interrupts();
	while(1)
	{
		ADC10_WaveSample(0);
		_nop();  		//öϵ㣬ȡADC10.cе
	}
}
/******************************************************************************************************
 *        ƣADC10_WaveSample(unsigned char inch)
 *        ܣһββ
 * ڲ
 * ڲ
 * ˵       64
 *        
 ******************************************************************************************************/
void  ADC10_WaveSample(unsigned char inch)
{
	int j=0,i=0;
     for( j=0;j<64;j++)        								//ѭ64
     {
      ADC10CTL0 |= ENC + ADC10SC;              // Sampling and conversion start
       for(i=0;i<300;i++);									//ʱ
       table_Valu[j]=ADC10MEM;
      }
}
/******************************************************************************************************
 *        ƣTimer0_A_Init()
 *        ܣTA0ʼ
 * ڲ
 * ڲ
 * ˵       TA0ڶʱıPWMռձȣʵǸıSPWMƵ
 *        
 ******************************************************************************************************/
void Timer0_A_Init()
{
  TA0CCTL0 = CCIE;                       					  // Ƚ/ģ0ж
  TA0CCR0 = cSMCLK/SIN_F/SIN_NUM;		  // úʵĲʱʱ
  TA0CTL = TASSEL_2 + MC_1;                		  // TA0Ϊģʽʱ=SMCLK
  _EINT();                                 							  // ȫж
}

/******************************************************************************************************
 *        ƣTimer0_A0()
 *        ܣTA0жӺ
 * ڲ
 * ڲ
 * ˵       ʱжһȹغжϲ
 *        
 ******************************************************************************************************/
#pragma vector=TIMER0_A0_VECTOR
__interrupt void Timer0_A0 (void)
{
	 _disable_interrupts();
	Change_Duty();
	_enable_interrupts();
}
/******************************************************************************************************
 *        ƣChange_Duty()
 *        ܣTA0ʱ¼
 * ڲ
 * ڲ
 * ˵       ұʱдTA1PWMռձ
 *        
 ******************************************************************************************************/
void Change_Duty()
{
	static  int i=0;
	unsigned int cnt=0;
	if(i>=SIN_NUM)
	{
		i=0;
		P1OUT^=BIT6;					                // Ϊʾͬźʾ۲SPWMź
	}
	cnt = (unsigned int)sin_table[i++];
	TA1CCR1 = cnt;										// Ҳ󣬸ռձ
}
