/**********DAC8411.c******************/


#include "MSP430G2553.h"
//--------IO궨----------
#define SYNC_HIGH 		P1OUT |=BIT0
#define SYNC_LOW  		P1OUT &=~BIT0
#define SCLK_HIGH 		P2OUT |=BIT2
#define SCLK_LOW 		P2OUT &=~BIT2
#define DIN_HIGH 		P1OUT |=BIT3
#define DIN_LOW 			P1OUT &=~BIT3
/******************************************************************************************************
 *        ƣDAC8411_Init()
 *        ܣʼDAC8411
 * ڲ
 * ڲ
 * ˵       ǳʼIO״̬
 *        
 ******************************************************************************************************/
void DAC8411_Init()
{
	//-----IOΪ-----
	P1DIR |=BIT0+BIT3;
	P2DIR |=BIT2;
	//-----IOʼ״̬Ϊ-----
	SCLK_HIGH;
	SYNC_HIGH;
}
/******************************************************************************************************
 *        ƣwrite2DAC8411(unsigned int Data)
 *        ܣDAC8411д16λ
 * ڲ
 * ڲ
 * ˵       跢18λͷλ016λDAC
 *        
 ******************************************************************************************************/
void write2DAC8411(unsigned int Data)
{
	unsigned int Temp;
	unsigned char i;
	Temp=Data;
	SYNC_LOW;			//ʹܿʼ
	//-----00Ƿǽģʽֹܾͣˣ-----
	SCLK_HIGH;
	DIN_LOW;			//0
	SCLK_LOW;

	SCLK_HIGH;
	DIN_LOW;			//0
	SCLK_LOW;
	//-----η16λ-----
	for(i=0;i<16;i++)
	{
		SCLK_HIGH;
		//-----ͨλ룬жλ10Ѿʲô-----
		if(Temp&BITF)	DIN_HIGH;
		else 		DIN_LOW;
		SCLK_LOW;
		Temp=Temp<<1;		//һλԶλ
	}
	SYNC_HIGH;	//ʹֹܽDAC8411
}








