/*
 * softFIFO.c
 *
 *  Created on: 2013-3-12
 *      Author: wangJingbing
 */

#include "msp430g2553.h"
#include "softFIFO.h"
#define DISABLE_INT				_DINT()		// ж
#define RESTORE_INT			_EINT()			// ж

/***********************º궨FIFOй******************************/
unsigned char FIFOBuff[FIFOBUFF_SIZE]={0}; 	//建(FIFO)
static unsigned int 	FIFO_IndexW;          	//дָ(ͷָ)
static unsigned int 	FIFO_IndexR;          		//жȡָ(βָ
unsigned int 	FIFO_Count;           					//FIFOδȡݵĸ
/****************************************************************************
*     ƣWrite_FIFO()
*     ܣһֵѹӦ̻
* ڲvalue:
* ڲ
****************************************************************************/
void Write_FIFO(unsigned char value)
{
  if(FIFO_Count>=FIFOBUFF_SIZE) return;//ֵ
  DISABLE_INT;
  FIFO_Count++;                       //
  FIFOBuff[FIFO_IndexW] = value;   //Ӷͷ׷µ
  if (++FIFO_IndexW >=  FIFOBUFF_SIZE) //ѭУͷָԽ
   {
	  FIFO_IndexW = 0;                  //ͷָصʼλ
   }
  RESTORE_INT;
}
/****************************************************************************
*     ƣRead_FIFO()
*     ܣӻڶȡһֵ
* ڲ
* ڲvalue
* ˵    : һθúԶɾһݡ
****************************************************************************/
unsigned char Read_FIFO()
{
	unsigned char value;
  if(FIFO_Count==0)  return(0);     	//ݣ0
  //DISABLE_INT;								//ввʱжִScanIOȫֱȷ
  FIFO_Count--;                     			//1
  value=FIFOBuff[FIFO_IndexR];    		//ӻβȡһ
  if (++FIFO_IndexR >= FIFOBUFF_SIZE)	//ѭУβָԽ
     {
	  FIFO_IndexR = 0;             			//βָصʼλ
     }
  //RESTORE_INT;                     				//ָж
  return(value);
}



