/*
 * Flash.c
 * ʵMSP430x2xxϵеƬ10ùܺ
(1)ʼFlash_Init(unsigned char Div,unsigned char Seg )SMCLKƵʼ趨FlashʱӵķƵϵSegκȷƻĶʼַ
(2)βFlash_Erase()β
(3)ֽڡFlash_ReadChar(unsigned int Addr)ȡƫƵַAddrλ1ֽڵݡ
(4)֡Flash_ReadWord(unsigned int Addr)ȡƫƵַAddrλ1ֵݡ
(5)һֽڵRAM顣Flash_ReadSeg(unsigned int Addr, unsigned int SegSize,char * Array)ȡʼƫƵַΪAddrSegSizeֽݵRAMArray顣
(6)ֱд1ֽڡFlash_Direct_WriteChar(unsigned int Addr)ֱдƫƵַAddrλ1ֽڵݡ
(7)ֱд1֡Flash_Direct_WriteWord(unsigned int Addr)ֱдƫƵַAddrλ1ֵݡ
(8)ݺд1ֽڡFlash_Bak_WriteChar(unsigned int Addr)ȱݶݣдƫƵַAddrλд1ֽڵݣٻԭݡϢflashΣʹRAMݣ
(9)ݺд1֡Flash_Bak_WriteWord(unsigned int Addr)ȱݶݣдƫƵַAddrλд1ֵݣٻԭݡϢflashΣʹRAMݣ
(10)SegAרúFlash_SegA_ReadChar(unsigned int Addr)ȡSegAƫƵַAddrλ1ֽڵݡ
˵ 1дҪRAMеúָʹã⺯δ漰
           2ֽڵͶдʹýṹ壬⺯δ漰
           3к޷ݣʹзΣ޸ĺ
           5InfoAεֻжֽںFlash_SegA_ReadChar()ṩд
           6Ķβ׵ַSegAddrFlash_Init()޶׷д
 *
 *  Created on: 2013-2-18
 *   Author: Administrator
 */
#include  "MSP430G2553.h"
unsigned int SegAddr=0;						//ȫֱ
unsigned int SegPre=0;						//ȫֱ ǰϢ
/******************************************************************************************************
*    	 ƣFlash_Init()
*   	 ܣFlashʱӽгʼ
* ڲDivSMCLKƵʼƵֵ趨Ϊ1-64
* 					Seg:κţΪ"0"-"31""A""B""C""D"
* ڲ1óɹ
*                   0ʧ
* ˵   	 FlashǰҪøóʼʱӷƵʹ׵ַ
*                   о־Եַֹ
*         Flash_Init(3,'B' ) 3ƵInfo Bβ
 ******************************************************************************************************/
unsigned char Flash_Init(unsigned char Div,unsigned char Seg )
{
	//-----FlashʱӺͷƵƵΪǡΪλֱDiv-1-----
	if(Div<1) Div=1;
	if(Div>64) Div=64;
	FCTL2 = FWKEY + FSSEL_2 + Div-1; 					// ĬʹSMCLKƵϵ
	//-----ΪFlashεͨ512ıöʼַ-----
	SegPre = Seg;														//ȡǰ
	if (Seg <= 31) 													//жǷFlash
		{
		SegAddr=0xFFFF-(Seg+1)*512+1;					//ʼַ
		return(1);														//ֵɹ󼴿˳سɹ־1
		}
	//-----ΪϢFlashεټ-----
	switch(Seg)														//жǷϢFlash
	{
	case 'A':	case'a': 	SegAddr=0x10C0; break;
	case 'B':	case'b': 	SegAddr=0x1080; break;
	case 'C':	case'c': 	SegAddr=0x1040; break;
	case 'D':	case'd': 	SegAddr=0x1000; break;
	default: 	SegAddr=0x20FF;	return(0);			//0x20FFַΪհFlash
	}
	return(1);
}
/******************************************************************************************************
*        ƣFlash_Erase()
*        ܣFlashһݿ飬дɳʼ Flash_Init()SegAddr
* ڲ
* ڲ
* ˵       и˲InfoFlashAεĲ루ע͵ˣѧʹá
*        
 ******************************************************************************************************/
void Flash_Erase()
{
  unsigned char *Ptr_SegAddr;                   			// Segment  pointer
  Ptr_SegAddr = (unsigned char *)SegAddr;  		// Initialize Flash  pointer
  FCTL1 = FWKEY + ERASE;                    					// βģʽ
  FCTL3 = FWKEY;                            						// 
  //FCTL3 = FWKEY+LOCKA;                          		    // InfoFlashAҲ
  _disable_interrupts();
  *Ptr_SegAddr = 0;                         						// 
  while(FCTL3&BUSY);                           					//Busy
  _enable_interrupts();
  FCTL1 = FWKEY;                           							// ȡģʽ
  FCTL3 = FWKEY+LOCK;                      	 				// 
  //FCTL3 = FWKEY+LOCK+LOCKA;                       // InfoFlashAҲ
}
/******************************************************************************************************
*     ƣFlash_ReadChar()
*     ܣFlashжȡһֽ
* ڲAddr:ݵƫƵַ
* ڲصݣƫʱ0
* ˵       
*        
 ******************************************************************************************************/
unsigned char Flash_ReadChar (unsigned int Addr)
{
  unsigned char Data=0;
  unsigned int *Ptr_SegAddr,temp=0;                    			// Segment  pointer
  //----- ηΧ޶Ϊڴȫֻβ-----
  if((SegPre<=31&&Addr>=512) ||(SegPre>31&&Addr>=64) )
	  return 0;
  temp =SegAddr+Addr;
  Ptr_SegAddr =(void*)temp;  		 				// Initialize Flash  pointer
  Data=*(Ptr_SegAddr);
  return(Data);
}
/******************************************************************************************************
*        ƣFlash_ReadWord()
*        ܣFlashROMһͱַӦΪż
* ڲAddr:ݵƫƵַ԰ֽڼ㣬Ϊż
* ڲصͱֵ  ƫʱ0
* ˵       
*        
 ******************************************************************************************************/
unsigned int Flash_ReadWord (unsigned int Addr)
{
  unsigned int *Ptr_SegAddr;
  unsigned int temp=0,Data=0;                    // Segment  pointer
  //----- ηΧ޶Ϊڴȫֻβ-----
  if((SegPre<=31&&Addr>=512) ||(SegPre>31&&Addr>=64) )
	  return 0;
  temp = SegAddr+Addr;
    Ptr_SegAddr = (void *)temp;  					// Initialize Flash pointer
  Data=*(Ptr_SegAddr);
  return(Data);
}
/******************************************************************************************************
*     ƣFlash_ReadSeg()
*     ܣFlashһݿRAMArray
* ڲAddrʼƫƵַ
* 					SegSizeݸ
* 					*ArrayRAMͷָ
* ڲسϢ 0:ƫ 1:
* ˵       
*        
 ******************************************************************************************************/
char Flash_ReadSeg(unsigned int Addr, unsigned int SegSize,unsigned char * Array)
{
	unsigned int i=0,temp=0;
	unsigned char *Ptr_SegAddr;                    		// Segment  pointer
	  //----- ηΧ޶Ϊڴȫֻβ-----
	if((SegPre<=31&&(Addr+SegSize)>512) ||(SegPre>31&&(Addr+SegSize)>64) )
	  return 0;
	for(i=0;i<SegSize;i++)
	{
		temp=SegAddr+Addr+i;								// ָֹƫƳ
		Ptr_SegAddr = (unsigned char *)temp;  	   	// Initialize Flash  pointer
		Array[i]=*Ptr_SegAddr;									//ָλֵ
	}
	  return 1;
}
/******************************************************************************************************
*     ƣFlash_Direct_WriteChar()
*     ܣǿFlashдһֽ(Charͱ)ǷΪ
* ڲAddr:ݵƫƵַ
            		Data:д
* ڲسϢ 0:ƫ 1:
*     Flash_Direct_WriteChar(0,123);123д0Ԫ
            	 Flash_Direct_WriteChar(1,a);ͱaд1Ԫ
 ******************************************************************************************************/
char Flash_Direct_WriteChar (unsigned int Addr,unsigned char Data)
{
	unsigned int temp=0;
	unsigned char *Ptr_SegAddr;                 	// Segment  pointer
	  //----- ηΧ޶Ϊڴȫֻβ-----
	if((SegPre<=31&&Addr>=512) ||(SegPre>31&&Addr>=64) )
	  return 0;
	temp = SegAddr+Addr;
	Ptr_SegAddr = (unsigned char *)temp;  	// Initialize Flash  pointer
	FCTL1=FWKEY+WRT;									//д״̬
	FCTL3=FWKEY;											//
//	FCTL3=FWKEY+LOCKA;								//AΣ
	_disable_interrupts();														//ж
	*Ptr_SegAddr=Data;									//ַָд1ֽ
	while(FCTL3&BUSY);									//ȴ
	_enable_interrupts();														//ж
	FCTL1=FWKEY;											//˳д״̬
	FCTL3=FWKEY+LOCK;								//ָ
//	FCTL3=FWKEY+LOCK+LOCKA;					//ָݣAΣ
	 return 1;
}
/******************************************************************************************************
*     ƣFlash_Direct_WriteWord()
*     ܣǿFlashдһͱܴ洢λǷȲ
* ڲAddr:ݵƫƵַ԰ֽڼ㣬Ϊż
            		Data:д
* ڲسϢ 0:ƫ 1:
*     Flash_Direct_WriteWord(0,123);123д0Ԫ
            	 Flash_Direct_WriteWord(2,a);ͱaд2Ԫ
 ******************************************************************************************************/
char Flash_Direct_WriteWord (unsigned int Addr,unsigned int Data)
{
	unsigned int temp=0;
	unsigned int *Ptr_SegAddr;                    	// Segment  pointer
	  //----- ηΧ޶Ϊڴȫֻβ-----
	if((SegPre<=31&&Addr>=512) ||(SegPre>31&&Addr>=64) )
	  return 0;
	temp=SegAddr+Addr;
	Ptr_SegAddr = (unsigned int *)temp;  	   	// Initialize Flash  pointer
	FCTL1=FWKEY+WRT;									//д״̬
	FCTL3=FWKEY;											//
//	FCTL3=FWKEY+LOCKA;								//AΣ
	_disable_interrupts();														//ж
	*Ptr_SegAddr=Data;									//д16λ
	while(FCTL3&BUSY);									//ȴ
	_enable_interrupts();														//ж
	FCTL1=FWKEY;											//˳д״̬
	FCTL3=FWKEY+LOCK;								//ָ
//	FCTL3=FWKEY+LOCK+LOCKA;					//ָݣAΣ
	 return 1;
}
/******************************************************************************************************
*     ƣFlash_Bak_WriteChar()
*     ܣƻݣFlashдһֽ(Charͱ)
* ڲAddr:ݵĵַ
            		Data:д
* ڲسϢ 0:ƫ 1:
*     Flash_Bak_WriteChar(0,123);123д0Ԫ
            	 Flash_Bak_WriteChar(1,a);aд1Ԫ
 ******************************************************************************************************/
char Flash_Bak_WriteChar (unsigned char Addr,unsigned char Data)
{
	unsigned int temp=0;
	unsigned char *Ptr_SegAddr;                    	// Segment  pointer
	unsigned char BackupArray[64];					//64ֽڵʱRAMSeg
	unsigned char i = 0;
	  //----- ηΧ޶Ϊڴȫֻβ-----
	if((SegPre<=31&&Addr>=512) || (SegPre>31&&Addr>64) )
	  return 0;
	for(i=0;i<64;i++)
	{
	  temp=SegAddr+i;
	  Ptr_SegAddr = (unsigned char *)temp;  	// Initialize Flash  pointer
	  BackupArray[i]=*Ptr_SegAddr;					//ָλֵ
	}
	Flash_Erase();  												//
	FCTL1 = FWKEY + WRT;                      			// д루ǿд
	FCTL3 = FWKEY ;                            					// 
//	FCTL3 = FWKEY ;                            					// AΣ
	for (i=0; i<64; i++)
	{
	_disable_interrupts();															//ж
	if(i==Addr)
	{
	  temp=SegAddr+Addr;
	  Ptr_SegAddr = (unsigned char *)temp;  	// Initialize Flash  pointer
	 *Ptr_SegAddr =Data;                    					// д
	 while(FCTL3&BUSY);                           			// ȴд
	 }
	else
	{
	  temp=SegAddr+i;
	  Ptr_SegAddr = (unsigned char *)temp;  	// Initialize Flash  pointer
	 *Ptr_SegAddr = BackupArray[i];           		// ָFlashڵ
	 while(FCTL3&BUSY);                             		// ȴд
	}
	_enable_interrupts();										// ж
	}
	FCTL1 = FWKEY;                           					// д
	FCTL3 = FWKEY + LOCK;                     			// 
// FCTL3 = FWKEY + LOCK;                     			// AΣ
	 return 1;
}
/******************************************************************************************************
*        ƣFlash_Bak_WriteWord()
*        ܣƻݣFlashдһ(intͱ)
* ڲAddr:ݵĵַȻֽΪλƫƵַΪż
            		Data:д
* ڲسϢ 0:ƫ 1:
* ˵       MSP430ƬԶ16λֱӲΪ˼ӿٶ
*                 оֱӶwordв
*        Flash_Bak_WriteWord(0,123);123д0Ԫ
            	 Flash_Bak_WriteWord(1,a);aд1Ԫ
 ******************************************************************************************************/
char Flash_Bak_WriteWord(unsigned int Addr,unsigned int Data)
{
	unsigned int *Ptr_SegAddr;                    			// Segment  pointer
	Ptr_SegAddr = (unsigned int *)SegAddr;  	   	// Initialize Flash  pointer
	//-----ע⣺²ȫΪword16λ-----
	unsigned int BackupArray[32];							//32(64ֽڣʱRAMSeg
	unsigned int i = 0;
	 //----- ηΧ޶Ϊڴȫֻβ-----
	if((SegPre<=31&&Addr>=512) ||(SegPre>31&&Addr>64) )
	return 0;
	for(i=0;i<32;i++)												//	wordռֽ
	{
	  BackupArray[i]= *(Ptr_SegAddr+i);					//ָλֵָ
	}
	Flash_Erase();  													//
	FCTL1 = FWKEY + WRT;                      				// д루ǿд
	FCTL3 = FWKEY;                            						// 
// FCTL3 = FWKEY+LOCKA;                            		// 	AΣ
	for (i=0; i<32; i++)												//	wordռֽڣַ
	{
	_disable_interrupts();										//ж
	if(i==Addr)
	{
	 *(Ptr_SegAddr+Addr) =Data;  							// д
	 while(FCTL3&BUSY);                           				// ȴд
	 }
	else
	{
	 *(Ptr_SegAddr+i)= BackupArray[i];           		// ָFlashڵݣָֻ
	 while(FCTL3&BUSY);                             			// ȴд
	}
	_enable_interrupts();											// ж
	}
	FCTL1 = FWKEY;                           						// д
	FCTL3 = FWKEY + LOCK;                     				// 
//	FCTL3 = FWKEY + LOCK+LOCKA;              		// LOCKA
	 return 1;
}
/******************************************************************************************************
*     ƣFlash_SegA_ReadChar()
*     ܣInfoAжȡһֽ
* ڲAddr:ݵƫƵַ
* ڲص;ƫʱ 0
 ******************************************************************************************************/
unsigned char Flash_SegA_ReadChar (unsigned int Addr)
{
	unsigned int temp=0;
	unsigned char Data;
	 //----- ηΧ޶Ϊڴȫֻβ-----
	if(Addr>=64)
		return 0;
	unsigned char *Ptr_SegAddr;                    // Segment  pointer
	temp = 0x10c0+Addr;
	Ptr_SegAddr = (unsigned char *)temp;  	// Initialize Flash  pointer
	Data=*Ptr_SegAddr;					   				//ֱΪInfoA׵ַδʹȫֱSegAddr
	return(Data);
}

