/*===================DCOУ========================
 * 32.768kHzƵУDCOƵʡ
 * УĲ˳InfoFLashBС
 * У黷ʵӦûһ£УƵֵȳУֵȷ
 * УĸʽУĸʽһ¡
 * УʱLaunchpad G2ϵĺƻУ̵
 * УϺP1.4ѭУDCOƵ
 * ==================ATTENTION======================
 * ȷCCS̵Erase OptionsΪѡErase main memory only
 * ֻInfoFlashBУŲΪ¼ʧInfoFlashA
 * дΪ¼ʧ ӼǶȣȻ԰УдInfoFlashA
 * 32ֽڣ0x10C00x10E0ͬʱУ0x10F80x10FF)
 * ȫźбдʵ֡
 **************************************************************************************************/
#include "MSP430G2553.h"
#include "Flash.h"
#define       CALDCO_MHz(x)			* (unsigned char *)(0x1080+(x-1)*2)			//ȡInfoFlashB
#define       CALBC1_MHz(x)				* (unsigned char *)(0x1080+(x-1)*2+1)
#define 		CAL_NUM 		16										/*УƵʵ*/
unsigned int Temp[128]={0};										/*ʵ128СƵMODxġƵ*/
unsigned char RSELx_DCOx_Winer[CAL_NUM]={0};	/*УSELxDCOxֵ*/
unsigned char MODx_Winer[CAL_NUM]={0};				/*УMODxֵ*/
unsigned int 	InfoFlash_Data[CAL_NUM]={0};				/*дinfoBеУƵʲ*/
unsigned int Ture_Freq[CAL_NUM]={0};						/*ʱ鿴ʵƵֵ*/

		// -----УƵʣλKHz-----
const unsigned int Calibrate_Frequence[CAL_NUM]={1000,2000,3000,4000,5000,6000,
		                                 7000,8000,9000,10000,11000,12000,13000,14000,15000,16000};

void DCO_Set_Freq(unsigned char Num,unsigned char mod_Temp);
void Measure_Temp();
void Find_RSELx_DCOx_Winer();
void Measure_MODx();
void Calculate_InfoFlash_Data();
void Write_InfoFlashB();
void DCO_InfoFlashB(unsigned int freq);
void Calibrate_Start();
void Calibrate_Finish();
void DCOTest();

void main(void)
{
	WDTCTL = WDTPW + WDTHOLD;				//ع
	//-----P1.4SMCLKȫʾƵʼƹ۲DCO----
	P1SEL |= BIT4;
	P1DIR |= BIT4;
	//-----ʼTAWDTжʹ-----
	TA0CTL = TASSEL_2+MC_2+TACLR;          	// SMCLKʱԴʼ
	IE1|=WDTIE;													//WDTж
	 _enable_interrupts();									//ͬ_ENTж
	//-----ʼDCOƵУ飬ֻһ-----
	Calibrate_Start();						//1ʾУDCO
	Measure_Temp();					//2Զ128Ƶ
	Find_RSELx_DCOx_Winer();	//3128ƵУҳӽԤƵʵǼ
	Measure_MODx();					//4ӵĴƵʻϣҵŵMODx
	Calculate_InfoFlash_Data();	//5ʵƵ趨ϳУ
	Write_InfoFlashB();					//6УдInfoFlahB
	Calibrate_Finish();					//7̵ʾУDCO
	//-----DCOУ飬FlashжʱȡУ׼ֵP1.4-----
	DCOTest();								//8ѭDCOУƵֵ۲
}
/******************************************************************************************************
 *        ƣCalibrate_Start()
 *        ܣɫLEDУ
 * ڲ
 * ڲ
 * ˵       DCOУʱȽϳúָʾԷԳ
 *        
 ******************************************************************************************************/
void Calibrate_Start()		//1ʾУDCO
{
	P1DIR |=BIT0+BIT6;
	P1OUT |= BIT0;				//ʾУ
	P1OUT &=~BIT6;
}
/******************************************************************************************************
 *        ƣMeasure_Temp()
 *        ܣԶβⶨ128ִDCOƵʣTemp[]
 * ڲ
 * ڲ
 * ˵       ƵָMOD=0ʱķǻƵ
 *        
 ******************************************************************************************************/
void Measure_Temp()			//2Զ128Ƶ
{
	unsigned long Freq_Temp=0;
	unsigned char RSELx_DCOx_Num=0;
	for(RSELx_DCOx_Num=0;RSELx_DCOx_Num<128;RSELx_DCOx_Num++)
	{
		DCO_Set_Freq(RSELx_DCOx_Num,0);
		//-----ʱƵ뿪ʼ-----
		TA0CTL |=TACLR;							//ʼ
		WDTCTL=WDT_ADLY_1_9;				//WDTʱΪѡ
		 _bis_SR_register(LPM0_bits);		//CPUȷ1.9ms(1/512)
		WDTCTL=WDTPW+WDTHOLD;
		Freq_Temp = TA0R;						//ȡֵDCO1/512ж
		//-----ʱƵ-----
		Temp[RSELx_DCOx_Num]=((Freq_Temp)*512)/1000;		//DCO׼ȷƵ
	}
}
/******************************************************************************************************
 *        ƣFind_RSELx_DCOx_Winer()
 *        ܣ128Temp[]Уҳ16УƵӽTemp
 * ڲ
 * ڲ
 * ˵       TempRSELxDCOxȡֵϢ
 *        
 ******************************************************************************************************/
void Find_RSELx_DCOx_Winer()		//3128ƵУҳӽԤƵʵǼ
{
	unsigned char i=0;
	unsigned int Delta_Min=0;
	unsigned int Delta_Now=0;
	unsigned char Calibrate_Num=0;
	for(Calibrate_Num=0;Calibrate_Num<CAL_NUM;Calibrate_Num++)
	{
		Delta_Min=65530;														//һαȽʱⶨһֵ
		for(i=0;i<128;i++)
		{
			//-----ȡСֵһҪСԤֵ-----
			if(Temp[i]<Calibrate_Frequence[Calibrate_Num])
				{
					Delta_Now=Calibrate_Frequence[Calibrate_Num]-Temp[i];
					if (Delta_Now<Delta_Min)							//ǰֵȡ¼Сʱ
						{
						RSELx_DCOx_Winer[Calibrate_Num]=i;		//Winner
						Delta_Min=Delta_Now;								//ȡǰ¼
						}
				}
		}
	}
}
/******************************************************************************************************
 *        ƣMeasure_MODx()
 *        ܣУɹRSELxDCOxһУʵMODx
 * ڲ
 * ڲ
 * ˵       ̶RSELxDCOx32MODxȡֵȻжŵMODx
 *        
 ******************************************************************************************************/
void Measure_MODx()		//4ӵĴƵʻϣҵŵMODx
{
	unsigned char mod_x = 0;
	unsigned long  Freq_Temp = 0;
	unsigned int Delta_Now=0;
	unsigned int Delta_Min=0;
    unsigned char Calibrate_Num=0;
	for(Calibrate_Num=0;Calibrate_Num<CAL_NUM;Calibrate_Num++)
	{
		Delta_Min=65530;											//һαȽʱⶨһֵ
		//-----RSELxDCOxһʱmod_xıʱϵƵ-----
		for(mod_x=0;mod_x <32;mod_x++)
		{
			DCO_Set_Freq(RSELx_DCOx_Winer[Calibrate_Num],mod_x);	//ımod_xDCO
			//-----ʱƵ뿪ʼ-----
			TA0CTL |=TACLR;
			WDTCTL=WDT_ADLY_1_9;
			 _bis_SR_register(LPM0_bits );					//CPUȷ1.9ms(1/512)
			WDTCTL=WDTPW+WDTHOLD;
			Freq_Temp = TA0R;									//ȡ"Ƶ"ֵ
			//-----ʱƵ-----
			Freq_Temp=((Freq_Temp)*512)/1000;		//DCO׼ȷƵ
			//-----Find_RSELx_DCOx_Winer()ͬҪֵС-----
			if(Freq_Temp<Calibrate_Frequence[Calibrate_Num])
			{
				Delta_Now=Calibrate_Frequence[Calibrate_Num]-(unsigned int )Freq_Temp;
			}
			else
			{
				Delta_Now=(unsigned int )Freq_Temp-Calibrate_Frequence[Calibrate_Num];
			}
			if (Delta_Now<Delta_Min)						//ǰֵȡ¼Сʱ
			{
				MODx_Winer[Calibrate_Num]=mod_x;									//Winner
				Ture_Freq[Calibrate_Num]=(unsigned int )Freq_Temp;		//¼У׼ȷƵ
				Delta_Min=Delta_Now;							//ȡǰ¼
			}
		}
	}
}
/******************************************************************************************************
 *        ƣCalculate_InfoFlash_Data()
 *        ܣУɹRSELxDCOxMODxװдFlash
 * ڲ
 * ڲ
 * ˵       16λݵĸʽȫճУ4λ̶1000ȻΪRSLEx
 * 					 DCOxMODx
 *        
 ******************************************************************************************************/
void Calculate_InfoFlash_Data()		//5ʵƵ趨ϳУ
{
	unsigned char RSELx=0;
	unsigned char DCOx=0;
	unsigned char i=0;
	for(i=0;i<CAL_NUM;i++)
	{
		RSELx=RSELx_DCOx_Winer[i]/8;
		DCOx=RSELx_DCOx_Winer[i]%8;
		//-----У׼16λʽΪ1000_RSELx_DCOx_MODx"-----
		InfoFlash_Data[i]=0x8000+(RSELx<<8)+(DCOx<<5)+MODx_Winer[i];
	}
}
/******************************************************************************************************
 *        ƣWrite_InfoFlashB()
 *        ܣõInfoFlash_Data[]飬дInfoFlashB
 * ڲ
 * ڲ
 * ˵       ȷCCS̵Erase OptionsΪѡErase main memory only
 * 					ֻInfoFlashBУŲΪ¼ʧ
 *        
 ******************************************************************************************************/
void Write_InfoFlashB()		//6УдInfoFlahB
{
	unsigned char i=0;
	//-----дFlashǰDCOʱһҪȷһ-----
    BCSCTL1 = CALBC1_1MHZ;      										/* Set DCO to 8MHz */
    DCOCTL = CALDCO_1MHZ;
    Flash_Init(3,'B');																// ʼFlash
	Flash_Erase();																	// Info_B
	//-----InfoFlash_Data[CAL_NUM]InfoFlashB-----
	for(i=0;i<CAL_NUM;i++)
		Flash_Direct_WriteWord(i*2,InfoFlash_Data[i]);		//ֱд
}
/******************************************************************************************************
 *        ƣCalibrate_Finish()
 *        ܣɫLEDʾDCOУ
 * ڲ
 * ڲ
 * ˵       ڳУһǡLEDָʾů
 *        
 ******************************************************************************************************/
void Calibrate_Finish()			//7̵ʾУDCO
{
	P1OUT |= BIT6;					//ʾУ
	P1OUT &=~BIT0;
}
/******************************************************************************************************
 *        ƣDCOTest()
 *        ܣ3ѭȡInfoFlashBеУݴ趨DCOƵ
 * ڲ
 * ڲ
 * ˵       ʾƵʼƽP1.4SMCLKڣʵDCOУ׼ȷ
 *        
 ******************************************************************************************************/
void DCOTest()											//8ѭDCOУƵֵ۲
{
	unsigned char i=1,freqCnt=1;
	WDTCTL=WDT_ADLY_1000;					//WDTжΪ1sһ
	while(1)													//൱ѭˣظлDCO
	{
		if(i++ >2)											//WTDжϻ(ʱ3s),лһƵ
		{
			i=1;
			if(freqCnt>CAL_NUM)					// Χƣ1~CAL_NUM
				freqCnt=1;
		//-----ճУCALDCO_xMHzCALBC1_xMHzʽDCOƵ-----
			DCOCTL=CALDCO_MHz(freqCnt);
			BCSCTL1=CALBC1_MHz(freqCnt);
			freqCnt++;
		}
		 _bis_SR_register(LPM0_bits);			//ȴ1sWDTжϻ
	}
}
/******************************************************************************************************
 *        ƣDCO_Set_Freq()
 *        ܣݴ趨DCOƵ
 * ڲNumNum0~2λʾDCOx3~6λʾRSELx
 * 					modTempMODx
 * ڲ
 * ˵       NumְDCOxRSELxϢ
 *        DCO_Set_Freq(10,5)ʾDCO趨ΪRSELx=1DCOx=2MODx=5
 ******************************************************************************************************/
void DCO_Set_Freq(unsigned char Num,unsigned char modTemp) //ò趨DCOƵ
{
	DCOCTL = ((Num%8)<<5)+modTemp;	//ݲ
	BCSCTL1 &=~0x0F;
	BCSCTL1 |=Num/8;
	__delay_cycles(15000);							//ȴDCOƵȶ
}
/******************************************************************************************************
 *        ƣWDT_ISR()
 *        ܣӦWDTʱжϷ
 * ڲ
 * ڲ
 * ˵       ڲֻ1份CPU룬дõWDTĶʱܣ
 * 					 ͬʱ⽫джϷУӰĿɶԡ
 *        
 ******************************************************************************************************/
#pragma vector=WDT_VECTOR
__interrupt void WDT_ISR(void)
{
	__bic_SR_register_on_exit(LPM0_bits );		//˳жʱCPU
}


