/*
 * PWM_LED.c
 * ӲLaunchpad G2553P1.3һP1.61̹LEDñӣ
 * µ˲䣬LEDȱ仯TA_PWM⺯
 *  Created on: 2013-4-8
 *  Author: Administrator
 */

#include "MSP430G2553.h"
#include "TA_PWM.h"

void P1_IODect();
void P13_Onclick();
void GPIO_init();

void main(void) {
	WDTCTL = WDTPW + WDTHOLD;	//ع
	//-----ʼTA0ΪACLK룬Ƶͨ1ǰPWMͨ2ر-----
	TA0_PWM_Init('A',1,'F',0);
	TA0_PWM_SetPeriod(500);				//趨PWM
	GPIO_init();											//ʼGPIO
	_enable_interrupts();							//ʹж
    _bis_SR_register(LPM3_bits);				//LPM3ʽ
}

/******************************************************************************************************
 *        ƣGPIO_Init()
 *        ܣ趨LEDIOķðIO
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
void GPIO_init()
{
	//----- TA0_PWM_Init()ԶTAڣP1.6-----

	//-----ϻеڲ-----
	P1REN |= BIT3;				        //P1.3ڲ
	P1OUT |= BIT3;			            //Ϊ
	//-----P1.3жϲ-----
	P1DIR &= ~BIT3;                    // P1.3Ϊ(ʡ)
	P1IES |= BIT3;                          // P1.3Ϊ½ж
	P1IE  |= BIT3 ;                          // P1.3ж
}

/******************************************************************************************************
 *        ƣPORT1_ISR()
 *        ܣӦP1ڵⲿжϷ
 * ڲ
 * ڲ
 * ˵       P1.0~P1.8PORT1жϣPORT1_ISR()бѯ־λP1IFG֪
 * 					 ĸIOⲿжϡP1IFGֶ򽫳PORT1жϡ
 *        
 ******************************************************************************************************/
#pragma vector = PORT1_VECTOR
__interrupt void PORT1_ISR(void)
{
	//-----Port1¼⺯-----
	P1_IODect();								//ͨ¼
   	P1IFG=0;                            			//˳жǰֶIOжϱ־
}

/******************************************************************************************************
 *        ƣP1_IODect()
 *        ܣжϾжϵIOӦIOж¼
 * ڲ
 * ڲ
 * ˵       ú8IOļ⣬ʵIO롱
 * 					 УP1.3IO7IOġ롱ûб
 *        
 ******************************************************************************************************/
void P1_IODect()
{
	unsigned int Push_Key=0;
	//-----ųIOĸźΨһжϱ־λ-----
	Push_Key=P1IFG&(~P1DIR);
	//-----ʱһʱ䣬ܿе-----
	__delay_cycles(10000);							//ʱ
	//----жϰ״̬Ƿʱǰһ-----
	if((P1IN&Push_Key)==0) 	                	//ôΰȷʵЧ
   {
	 //----жϾĸIO£øIO¼-----
	  switch(Push_Key){
//	 case BIT0:	P10_Onclick();		break;
//	 case BIT1: 	P11_Onclick();		break;
//	 case BIT2: 	P12_Onclick();		break;
	 case BIT3: 	P13_Onclick();		break;
//	 case BIT4: 	P14_Onclick();		break;
//	 case BIT5: 	P15_Onclick();		break;
//	 case BIT6: 	P16_Onclick();		break;
//	 case BIT7: 	P17_Onclick();		break;
	 default:									break;		//κ¾default
	 }
   }
}

/******************************************************************************************************
 *        ƣP13_Onclick()
 *        ܣP1.3ж¼P1.3ºһʲô
 * ڲ
 * ڲ
 * ˵       ʹ¼ʽǿֲԺͿɶ
 *        
 ******************************************************************************************************/
void P13_Onclick()									//P1.3¼
{
	//-----BrightںִܱգԵΪֲ̬-----
	static unsigned int Bright=0;
	//-----ѭıPWMռձ-----
	Bright=Bright+40;
	if(Bright>=400)									//ռձ40%Ӿ仯
		Bright=0;
	TA0_PWM_SetPermill(1,Bright);		//ÿ⺯PWMռձ
	_nop();
	}
