/*
 * Key_Long_Short
 * ӲLaunchpad G2553P1.3һP1.0P1.61LEDñӣ
 * ʹ״̬б𳤶̰̰лLED1״̬лLED2״̬
 *  Created on: 2013-4-8
 *  Author: Administrator
 */
#include "MSP430G2553.h"

//-----״̬к궨-----
#define IDLE						0
#define SHORT					1
#define LONG					2
#define COUNTER_THRESHOLD   30		/*б*/
//-----ȫֱ-----
unsigned char WDT_Counter=0;				/*ڶ԰ʱм*/

//-----mainǰǰ-----
void GPIO_init();
void WDT_init();
void Key_SM();
unsigned char LongClick_Dect();
void P13_OnShortRelease();
void P13_OnLongClick();

/******ΪĶϰߣmainǰ棬ͱǰ***/
void main(void) {
	WDTCTL = WDTPW + WDTHOLD;	//ع
	GPIO_init();
	WDT_init();
	_enable_interrupts();							//ж
	_bis_SR_register(LPM3_bits);				//LPM3
}

/******************************************************************************************************
 *        ƣGPIO_Init()
 *        ܣ趨LEDIOķðIO
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
void GPIO_init()
{
	//-----趨P1.0P1.6ʼֵ-----
	P1DIR |= BIT0+BIT6;				//趨P1.0P1.6Ϊ
	P1OUT |= BIT0;						//趨P1.0ֵ
	P1OUT &= ~BIT6;					//趨P1.6ֵ
	//-----ϻеڲ-----
	P1REN |= BIT3;				        //P1.3ڲ
	P1OUT |= BIT3;			            //Ϊ
}
/******************************************************************************************************
 *        ƣWDT_init()
 *        ܣ趨WDTʱжΪ16msWDTʱжʹ
 * ڲ
 * ڲ
 * ˵       WDTʱжϵʱԴѡACLKLPM3ߡ
 *        
 ******************************************************************************************************/
void WDT_init()
{
	//-----趨WDTΪ-----
	WDTCTL=WDT_ADLY_16;
	//-----WDTжʹ-----
    IE1|=WDTIE;
}
/******************************************************************************************************
 *        ƣWDT_ISR()
 *        ܣӦWDTʱжϷ
 * ڲ
 * ڲ
 * ˵       ֱж¼״̬
 *        
 ******************************************************************************************************/
#pragma vector=WDT_VECTOR
__interrupt void WDT_ISR(void)
{
	//-----ð״̬-----
	Key_SM();
}
/******************************************************************************************************
 *        ƣKey_SM()
 *        ܣжϳ̼
 * ڲ
 * ڲ
 * ˵       ״̬ΪMealy״̬Switch(State)Ҫж¼
 *        
 ******************************************************************************************************/
void Key_SM()
{
	static unsigned char State;					//״̬״̬
	static unsigned char Key_Now;			//¼ĵǰƽ
	unsigned char Key_Past=0;					//¼ǰһεƽ
	unsigned char Key_Dect=0;					//״ֵ̬
	Key_Past=Key_Now;
	//-----ѯIOĴ-----
	if(P1IN&BIT3) 	Key_Now=1;
	else 					Key_Now=0;
	//-----ƽǰߺͣ-----
	if((Key_Past==1)&&(Key_Now==0))
		Key_Dect=1;
	//-----ƽǰͺߣ-----
	if((Key_Past==0)&&(Key_Now==1))
		Key_Dect=2 ;
	switch(State)			//״̬ɨİֵKey_Dectת״̬
	{
	case IDLE:  		WDT_Counter=0;					//״̬Լ
							if(Key_Dect==1) 	State=SHORT;	break;	//·1
	case SHORT:  	if(Key_Dect==2)										   	//·2
								{
									State=IDLE;
									P13_OnShortRelease();	//̰¼
								}
							if(LongClick_Dect())									//·3
								{
									State=LONG;
									P13_OnLongClick();		//¼
								}
																					break;
	case LONG:		 WDT_Counter=0; 					//״̬Լ
							if(Key_Dect==2) 	State=IDLE;		break;	 //·4
	default: 			State=IDLE;										break;
	}
}

 /******************************************************************************************************
  *        ƣLongClick_Dect()
  *        ܣWDTжϼʱ㲢ءϢ
  * ڲ
  * ڲ
  * ˵       
  *        
  ******************************************************************************************************/
unsigned char LongClick_Dect()
{
	WDT_Counter++;
	if (WDT_Counter==COUNTER_THRESHOLD)
	{
		WDT_Counter=0;
		return(1);
	}
	else return(0);
}
/******************************************************************************************************
 *        ƣP13_OnShortRelease()
 *        ܣP1.3Ķ̰¼P1.3̰һʲô
 * ڲ
 * ڲ
 * ˵       ʹ¼ʽǿֲԺͿɶ
 *        
 ******************************************************************************************************/
void P13_OnShortRelease()					//P1.3¼
{
	//----תP1.3IOƽ-----
	P1OUT ^= BIT0;
}
/******************************************************************************************************
 *        ƣP13_OnLongClick()
 *        ܣP1.3ĳ¼P1.3һʲô
 * ڲ
 * ڲ
 * ˵       ʹ¼ʽǿֲԺͿɶ
 *        
 ******************************************************************************************************/
void P13_OnLongClick()					//P1.3¼
{
	//----תP1.6IOƽ-----
	P1OUT ^= BIT6;
}




