/*
 * TouchPad_Long_Short_Mealy
 * ӲP1.0P1.6ֱ1LED1̹LEDñӣP2.0P2.5
 * ̰P2.0л𣬳P2.0л̵
 *        עûе״̬жϳ̼
 *  Created on: 2013-4-8
 *  Author: Administrator
 */
#include "MSP430G2553.h"
#include "TouchIN.h"

//-----״̬к궨-----
#define IDLE						0
#define SHORT					1
#define LONG					2

#define COUNTER_THRESHOLD   30		/*б*/

//-----ȫֱ-----
unsigned char WDT_Counter=0;				/*ڶ԰ʱм*/

//-----mainǰǰ----
void GPIO_init();
void WDT_init();
void Key_SM();
unsigned char LongClick_Dect();
void P20_Touch_OnShortRelease();
void P20_Touch_OnLongClick();

/******ΪĶϰߣmainǰ棬ͱǰ***/
void main(void) {
	WDTCTL = WDTPW + WDTHOLD;	//ع
	GPIO_init();
	WDT_init();
	_enable_interrupts();
	_bis_SR_register(LPM3_bits);
}

/******************************************************************************************************
 *        ƣGPIO_Init()
 *        ܣ趨LEDIOķðIO
 * ڲ
 * ڲ
 * ˵       ʹôʱʹڲ
 *        
 ******************************************************************************************************/
void GPIO_init()
{
	//-----趨P1.0P1.6ʼֵ-----------
	P1DIR |= BIT0+BIT6;				//趨P1.0P1.6Ϊ
	P1OUT |= BIT0;						//趨P1.0ֵ
	P1OUT &= ~BIT6;					//趨P1.6ֵ
//	//-----ʹP2.0P1.3е-------
//	P1REN |= BIT3;				        //P1.3ڲ
//	P1OUT |= BIT3;			            //Ϊ
}
/******************************************************************************************************
 *        ƣWDT_init()
 *        ܣ趨WDTʱжΪ16msWDTʱжʹ
 * ڲ
 * ڲ
 * ˵       WDTʱжϵʱԴѡACLKLPM3ߡ
 *        
 ******************************************************************************************************/
void WDT_init()
{
	//-----趨WDTΪ-----------
	WDTCTL=WDT_ADLY_16;
	//-----WDTжʹ----------------------
    IE1|=WDTIE;
}
/******************************************************************************************************
 *        ƣWDT_ISR()
 *        ܣӦWDTʱжϷ
 * ڲ
 * ڲ
 * ˵       ֱж¼״̬
 *        
 ******************************************************************************************************/
#pragma vector=WDT_VECTOR
__interrupt void WDT_ISR(void)
{
	//-----״̬붨ʱ---
	TouchIN_Dect();
	//----ð״̬----
	Key_SM();
}
/******************************************************************************************************
 *        ƣKey_SM()
 *        ܣжϳ̼
 * ڲ
 * ڲ
 * ˵       ״̬ΪMealy״̬Switch(State)Ҫж¼
 *        
 ******************************************************************************************************/
void Key_SM()
{
	static unsigned char State;					//״̬״̬
	static unsigned char Key_Now;			//¼ĵǰƽ
	unsigned char Key_Past=0;					//¼ǰһεƽ
	unsigned char Key_Dect=0;					//״ֵ̬
	Key_Past=Key_Now;
	//-----ѯIOĴ-----
//	if(P1IN&BIT3) 	Key_Now=1;
	if(TouchIN&BIT0) 	Key_Now=1;			//P1.3ΪTouchIN.0
	else 					Key_Now=0;
	//----- ʶǰ01-----
//	if((Key_Past==1)&&(Key_Now==0))
	if((Key_Past==0)&&(Key_Now==1))		//е߼෴
		Key_Dect=1;
	//----- ʶǰ10ɿ-----
	if((Key_Past==1)&&(Key_Now==0))		//е߼෴
		Key_Dect=2 ;
	switch(State)			//״̬ɨİֵKey_Dectת״̬
	{
	case IDLE:  		WDT_Counter=0;					//״̬Լ
							if(Key_Dect==1) 	State=SHORT;	break;	//·1
	case SHORT:  	if(Key_Dect==2)										   	//·2
								{
									State=IDLE;
//									P13_OnShortRelease();		//̰¼
									P20_Touch_OnShortRelease();	//ΪP2.0̰¼
								}
							if(LongClick_Dect())									//·3
								{
									State=LONG;
//									P13_OnLongClick();			//¼
									P20_Touch_OnLongClick();		//ΪP2.0¼
								}
																					break;
	case LONG:		 WDT_Counter=0; 					//״̬Լ
							if(Key_Dect==2) 	State=IDLE;		break;	 //·4
	default: 			State=IDLE;										break;
	}
}

/******************************************************************************************************
 *        ƣLongClick_Dect()
 *        ܣWDTжϼʱ㲢ءϢ
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
unsigned char LongClick_Dect()
{
	WDT_Counter++;
	if (WDT_Counter==COUNTER_THRESHOLD)
	{
		WDT_Counter=0;
		return(1);
	}
	else return(0);
}
/******************************************************************************************************
 *        ƣP20_Touch_OnShortRelease()
 *        ܣP2.0Ĵ̰¼P2.0̰һʲô
 * ڲ
 * ڲ
 * ˵       ʹ¼ʽǿֲԺͿɶ
 *        
 ******************************************************************************************************/
void P20_Touch_OnShortRelease()					//P1.3¼
{
	//----תIOƽ-----
	P1OUT ^= BIT0;
}
/******************************************************************************************************
 *        ƣP20_Touch_OnLongClick()
 *        ܣP2.0Ĵ¼P2.0һʲô
 * ڲ
 * ڲ
 * ˵       ʹ¼ʽǿֲԺͿɶ
 *        
 ******************************************************************************************************/
void P20_Touch_OnLongClick()					//P1.3¼
{
	//----תIOƽ-----
	P1OUT ^= BIT6;
}
