/*
 * USCI_I2C.c
 *
 *  Created on: 2013-4-6
 *      Author: Administrator
 */
#include"MSP430G2553.h"

#define TX_STATE 						0					/*I2C״̬*/
#define RX_STATE						1					/*I2C״̬*/
//-----SMCLKƵI2CͨŲ-----
#define I2C_BAUDRATE_DIV 	14				/*I2Cʿ*/
#define SLAVE_ADDR 				0x20				/*ӻTCA6416Aĵַ*/
static unsigned char  TxByteCnt=0;				//ʣ෢
static unsigned char  RxByteCnt=0;				//ʣ
static unsigned char *pTxData;                     // TX ݵָ
static unsigned char *pRxData;                     // Rxմݵָ
unsigned char I2C_State =  0;						//շ״ָ̬ʾ
/******************************************************************************************************
 *        ƣUSCI_I2C_Init()
 *        ܣʼUSCI_B0ģΪI2Cģʽ
 * ڲ
 * ڲ
 * ˵       I2CΪ3״̬ݲʹTxRxж
 *        
 ******************************************************************************************************/
void USCI_I2C_Init()
{
	 _disable_interrupts();
	  P1SEL |= BIT6 + BIT7;                      						// GPIO ΪUSCI_B0
	  P1SEL2|= BIT6 + BIT7;                    						 // GPIO ΪUSCI_B0
	  UCB0CTL1 |= UCSWRST;                      					 // λ״̬
	  UCB0CTL0 = UCMST + UCMODE_3 + UCSYNC;   // ͬͨI2C״̬
	  UCB0CTL1 = UCSSEL_2 + UCSWRST;            		 // ʹSMCLKλ״̬
	  UCB0BR0 =I2C_BAUDRATE_DIV ;                          // ˷ƵϵʵʲʻSMCLKй
	  UCB0BR1 = 0;														//һķƵһ㲻
	  UCB0I2CSA = SLAVE_ADDR;                    			// I2Cӻַں궨޸
	  UCB0CTL1 &= ~UCSWRST;                     				// I2C
	  _enable_interrupts();
}
/******************************************************************************************************
 *        ƣUSCI_I2C_Tx_Init()
 *        ܣʹI2CTxж
 * ڲ
 * ڲ
 * ˵       I2Cֻͨܰ˫ֻʹһжϣɿ
 *        
 ******************************************************************************************************/
void USCI_I2C_Tx_Init()
{
	  _disable_interrupts();
	  while ((UCB0STAT & UCBUSY)||UCB0CTL1 & UCTXSTP);       // ȷ߿
	  IE2 &= ~UCB0RXIE;							//رRxж
	  I2C_State=TX_STATE;
	  IE2 |= UCB0TXIE;                          	    //Txж
	  _enable_interrupts();						// ж
}
/******************************************************************************************************
 *        ƣUSCI_I2C_Rx_Init()
 *        ܣʹI2CRxж
 * ڲ
 * ڲ
 * ˵       I2Cֻͨܰ˫ֻʹһжϣɿ
 *        
 ******************************************************************************************************/
void USCI_I2C_Rx_Init()
{
	 _disable_interrupts();
	  while ((UCB0STAT & UCBUSY)||UCB0CTL1 & UCTXSTP);       // ȷ߿
	  IE2 &= ~UCB0TXIE;							//رRxж
	  I2C_State=RX_STATE;
	  IE2 |= UCB0RXIE;                          	    //Txж
	  _enable_interrupts();						// ж
}
/******************************************************************************************************
 *        ƣPreSet_Tx_Frame()
 *        ܣݵġС
 * ڲ
 * ڲ
 * ˵       ֻвBUSYSTOPѸλ²С
 *        
 ******************************************************************************************************/
unsigned char PreSet_Tx_Frame(unsigned char *p_Tx,unsigned char num)
{
	if ((UCB0STAT & UCBUSY)||(UCB0CTL1 & UCTXSTP))		return(0);
 	pTxData = (unsigned char *)p_Tx;     	// ָ
    TxByteCnt = num;                  					// ʣ෢ݸ
    UCB0CTL1 |= UCTR + UCTXSTT;            // I2C Txλ, start condition
    _bis_SR_register(CPUOFF+GIE);       		// LPM0ģʽж
    return(1);
}
/******************************************************************************************************
 *        ƣPreSet_Rx_Frame()
 *        ܣݵġС
 * ڲ
 * ڲ
 * ˵       ֻвBUSYSTOPѸλ²С
 *        
 ******************************************************************************************************/
unsigned char PreSet_Rx_Frame(unsigned char *p_Rx,unsigned char num)
{
	if ((UCB0STAT & UCBUSY)||(UCB0CTL1 & UCTXSTP))		return(0);
	pRxData = (unsigned char *)p_Rx;     	// ָ
	 RxByteCnt= num;                  				// ʣݸ
	 UCB0CTL1 &= ~UCTR;
     UCB0CTL1 |= UCTXSTT;                    		// I2C Rxλ, start condition
    _bis_SR_register(CPUOFF+GIE);       	    //  LPM0ģʽж
    return(1);
 }
void I2C_TxFrame_ISR(void);
void I2C_RxFrame_ISR(void);
/******************************************************************************************************
 *        ƣUSCIAB0TX_ISR()
 *        ܣӦI2CշжϷ
 * ڲ
 * ڲ
 * ˵       I2CTxRxж
 *        
 ******************************************************************************************************/
#pragma vector = USCIAB0TX_VECTOR
__interrupt void USCIAB0TX_ISR(void)
{
	 _disable_interrupts();							//ͬ_DINT
  if(I2C_State==TX_STATE)							//ж״̬Ƿ״̬
    I2C_TxFrame_ISR();                        			// ¼֡
  else
	I2C_RxFrame_ISR();                     			// ¼֡
  	//-------ԤѭлCPU;-------
  	  if(RxByteCnt == 0 || TxByteCnt == 0)	//ûдͻ
  	    __bic_SR_register_on_exit(CPUOFF);   // Exit LPM0
  	 _enable_interrupts();							//ͬ_ENIT
}
/******************************************************************************************************
 *        ƣI2C_TxFrame_ISR()
 *        ܣI2CTx¼ͻе
 * ڲ
 * ڲ
 * ˵       FIFOָѭ
 *        
 ******************************************************************************************************/
void I2C_TxFrame_ISR(void)
{
   if (TxByteCnt)                            			// Ƿ
  {
    UCB0TXBUF = *pTxData;                   // װ
    pTxData++;											//ָλ
    TxByteCnt--;                            			// ݸݼ
  }
  else														//ݷ
  {
    UCB0CTL1 |= UCTXSTP;                   	// ֹͣλ
    IFG2 &= ~UCB0TXIFG;                     	// ˹־λûдBufferMCUԶ
  }
}
/******************************************************************************************************
 *        ƣI2C_RxFrame_ISR()
 *        ܣI2CRx¼ȡUCB0RXBUFдָ
 * ڲ
 * ڲ
 * ˵       ƶFIFOָѭ
 *        
 ******************************************************************************************************/
void I2C_RxFrame_ISR(void)
{
	  if (RxByteCnt == 1)                       			// ֻʣ1ֽûʱʵѾRxBuffˣ
	      UCB0CTL1 |= UCTXSTP;                  		// ֹͣλ
	  RxByteCnt--;                              				// ֽݼ
	  *pRxData = UCB0RXBUF;                  		// 洢ѽյ
	  *pRxData++;												//ָλ
}
