/*
 * Slope.c
 *
 *  Created on: 2013-4-3
 *      Author: Administrator
 */
#include "MSP430G2553.h"
#include "Timer_A3.h"
#include "ComparatorA.h"
#define PORT_REF_LOW 		P1DIR |= BIT3;P1OUT &=~BIT3		//οIO0
#define PORT_REF_HIGH 		P1DIR |= BIT3;P1OUT |=BIT3			//οIO1
#define PORT_REF_HZ			P1DIR &= ~BIT3								//οIO
#define PORT_SENS_LOW	 	P2DIR |= BIT2;P2OUT &=~BIT2		//IO0
#define PORT_SENS_HIGH	P2DIR |= BIT2;P2OUT |=BIT2			//IO1
#define PORT_SENS_HZ		 P2DIR &=~BIT2								//IO
#define TAR_CLEAR				TA0CTL |= TACLR							//TAʱӼֵ

unsigned char Slope_Measure_Flag=0;			//ȫֱ־ʶǰʲô
unsigned int R_REF=0;			//ȫֱοԡֵ
unsigned int R_SENS=0;		//ȫֱԡֵ
/******************************************************************************************************
 *        ƣSlope_Port_Charge()
 *        ܣԴһֱֵϵĵ
 * ڲ
 * ڲ
 * ˵       󣬵ȴŵźš
 *        
 ******************************************************************************************************/
void Slope_Port_Charge()
{
	PORT_SENS_HIGH;
	PORT_REF_HIGH;
}
/******************************************************************************************************
 *        ƣSlope_Measure_Init()
 *        ܣʼӲģ飬ݳȴһηŵ
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
void Slope_Measure_Init()
{
	Comparator_Aplus_init();
	Timer0_A3_init();
	Slope_Port_Charge();
}
/******************************************************************************************************
 *        ƣSlope_Measure_REF()
 *        ܣοĲ
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
void  Slope_Measure_REF()
{
	Slope_Measure_Flag=0;			//ȫֱ־˴βǲο
	PORT_SENS_HZ;						//IO裬ȥԵ·Ӱ
	TAR_CLEAR;								//TAʱ
	PORT_REF_LOW;						//οŵͨʼŵʱ
}
/******************************************************************************************************
 *        ƣSlope_Measure_SENS()
 *        ܣĲ
 * ڲ
 * ڲ
 * ˵       
 *        
 ******************************************************************************************************/
void Slope_Measure_SENS()
{
	Slope_Measure_Flag=1;			//ȫֱ־˴βǴ
	PORT_REF_HZ;						//οIO裬ȥԵ·Ӱ
	TAR_CLEAR;								//TAʱ
	PORT_SENS_LOW;					//ŵͨʼŵʱ
}
/******************************************************************************************************
 *        ƣSlope_TA_CCI1B()
 *        ܣSlopeӦõĲж¼õֵ
 * ڲ
 * ڲ
 * ˵       ݱʶλжϱβǲο軹Ǵ
 *        
 ******************************************************************************************************/
void Slope_TA_CCI1B()
{
	switch(Slope_Measure_Flag)
	{
		case 0 : 	R_REF= TA0CCR1;			break;
		case 1 :	R_SENS= TA0CCR1;	    break;
		default:	break;
	}
}


