/*
 * TA_PWM.c
 * PWM⺯TAPWM
 *  Created on: 2013-2-9
 *  Author: Administrator
 */

#include "msp430g2553.h"
#define DEADTIME 20							//Ԥʱ䣬TAclkΪλ
/*******趨TAIOڣĿǰ趨ΪMSP430G255320PinװTA0.2********/
#define TA01_SET 	P1SEL |= BIT6; P1DIR |= BIT6		//P1.6
#define TA02_SET 	P3SEL |= BIT0; P3DIR |= BIT0		//P3.0
#define TA11_SET 	P2SEL |= BIT2; P2DIR |= BIT2		//P2.2
#define TA12_SET 	P2SEL |= BIT4; P2DIR |= BIT4		//P2.4
#define TA01_OFF 	P1SEL&= ~BIT6 							//P1.6
#define TA02_OFF 	P3SEL &= ~BIT0 						//P3.0
#define TA11_OFF 	P2SEL &= ~BIT2 						//P2.2
#define TA12_OFF 	P2SEL &= ~BIT4							//P2.4
/******************************************************************************************************
*        ƣTA0_PWM_Init()
*        ܣTA0ʱΪPWMĳʼú
* ڲClk:ʱԴ 'S'=SMCLK;   'A'=ACLK ;   'E'=TACLK(ⲿ) 'e'= TACLK(TACLKȡ)
                    Div:ʱӷƵϵ: 1/2/4/8
		    Mode1:ͨ1ģʽ 'F'ΪǰPWMģʽ7'B'ͺPWMģʽ3 'D'PWMģʽ60=
		    Mode2:ͨ2ģʽ 'F'ΪǰPWMģʽ7'B'ͺPWM ģʽ3'D'PWMģʽ20=
		    ƵPWMʱͨʹãҾΪģʽ
* ڲ1ʾóɹ0ʾʧܡ
* ˵        : ڵPWMغ֮ǰҪøúTAģʽʱԴ
*         : TA0_PWM_Init('A',1,'F','P')TAʱΪACLK,ͨ1ͨ2ΪǰPWM
                   TA0_PWM_Init('S',4,'D','D')TAʱΪSMCLK/4, ͨ1ΪPWMͨ2ΪPWM
                   TA0_PWM_Init('A',1,'F',0)TAʱΪACLK,ͨ1ǰPWMͨ2TAá
 ******************************************************************************************************/
char TA0_PWM_Init(char Clk,char Div,char Mode1,char Mode2)
{
  TA0CTL =0;																		// ǰ

  switch(Mode1)																	//Ϊʱѡģʽ
  {
  case 'F': case 'f':																//ͨPWM
		  TA0CTL |=MC_1; break;											//ʱΪ
  case 'B':case 'b':
	  	  TA0CTL |=MC_1; break;											//ʱΪ
  case 'D': case 'd':																//PWM
     	  TA0CTL |=MC_3; break;											//ʱΪ
  default : return(0);															//ò󣬷0
  }

  switch(Clk)  																		//ΪʱTAѡʱԴ
  {
    case 'A': case 'a':  	TA0CTL|=TASSEL_1; break;   			//ACLK
    case 'S': case 's': 	TA0CTL|=TASSEL_2; break;  			//SMCLK
    case 'E':            		TA0CTL|=TASSEL_0; break;  			//ⲿ(TACLK)
    case 'e':          			TA0CTL|=TASSEL_3; break;   			//ⲿ(TACLKȡ)
    default :  return(0);  														//ò󣬷0
  }
  switch(Div) 																		//ΪʱTAѡƵϵ
  {
    case 1:   TA0CTL|=ID_0; break;   //1
    case 2:   TA0CTL|=ID_1; break;   //2
    case 4:   TA0CTL|=ID_2; break;   //4
    case 8:   TA0CTL|=ID_3; break;   //8
    default :  return(0);  														//ò󣬷0
  }
  switch(Mode1)										 							//PWMͨ1ģʽ
  {
     case 'F':	case 'f':
              TA0CCTL1 = OUTMOD_7;
              TA01_SET;
              break;
     case 'B':	case 'b':
              TA0CCTL1 = OUTMOD_3;
              TA01_SET;
              break;
     case 'D': case'd':
	     TA0CCTL1 = OUTMOD_6;
    	     TA01_SET;
    	     break;
      case '0':case 0:   															//Ϊ
             TA01_OFF;   															//TA0.1ָΪͨIO
              break;
     default :  return(0); 							  							//ò󣬷0
  }
  switch(Mode2) 																//PWMͨ2ģʽ
  {
      case 'F':	 case 'f':
              TA0CCTL2 = OUTMOD_7;
              TA02_SET;  break;
       case 'B':	case 'b':
              TA0CCTL2 = OUTMOD_3;
              TA02_SET;
                break;
       case 'D': case 'd':
	       	   TA0CCTL2 = OUTMOD_2;
	       	   TA02_SET;
	       	   break;
       case '0':case 0:   														//Ϊ
           	 	TA02_OFF;   							 						//TA0.1ָΪͨIO
           	 	break;
       default :  return(0); 												//ò󣬷0
    }
  return(1);
}
/******************************************************************************************************
*        ƣTA0_PWM_SetPeriod()
*        ܣPWM
* ڲChannel: TA0=0, TA1=1
*                     Period:(0~65535) ʱӸ
* ڲ1óɹ     0ʧ
* ˵        : ͨPWMPWMһ
*         : TA0_PWM_SetPeriod(500)PWMΪ5001000ʱ
 ******************************************************************************************************/
char TA0_PWM_SetPeriod(unsigned int Period)
{
	if (Period>65535)	return(0);
	 TA0CCR0 = Period;
	return(1);
}

/******************************************************************************************************
*     ƣTA0_PWM_SetPermill()
*     ܣPWMռձ(ǧֱ)
* ڲChannel: ǰõͨ  1/2
            Duty: PWMߵƽЧʱǧֱ (0~1000)
* ڲ1óɹ0ʧ
* ˵    : 1000=100.0%  500=50.0% ơģʽʱchannelͬʱ趨
*     : TA0_PWM_SetPermill(1,300)PWMͨ1ռձΪ30.0%
               TA0_PWM_SetPermill(2,,825)PWMͨ2ռձΪ82.5%
 ******************************************************************************************************/
char TA0_PWM_SetPermill(char Channel,unsigned int Duty)
{
	unsigned char Mod = 0;
	unsigned int DeadPermill=0;
	unsigned long int Percent=0;							//ֹ˷ʱ
	Percent=Duty;
	DeadPermill=((DEADTIME*1000)/TACCR0);		//ʱ任ǧֱʱ
	switch (Channel)												//жϳͨĹģʽ
		{
	case 1:
		Mod = (TA0CCTL1& 0x00e0)>>5;		break;	//ȡģʽOUTMOD0λ5-7λ
	case 2:
		Mod = (TA0CCTL2 & 0x00e0)>>5;	break;	//ȡģʽOUTMOD1λ5-7λ
	default:	return(0);
		}

	switch(Mod)														//ģʽ趨TACCRx
		{
	case 2: case 6:			/**ģʽ2,6ʱҪжʱ䣬ͬʱ趨TA0CCR1/2 ֵ*/
		{
			if((1000-2*Percent)<=DeadPermill)			//Ԥʱ
				Percent=(1000-DeadPermill)/2;
			TA0CCR1=Percent*TA0CCR0/1000;
			TA0CCR2= TA0CCR0-TA0CCR1;
			break;
		}
		case 7:
		{
			if(Percent>1000)	Percent=1000;
			if(Channel==1) TA0CCR1=Percent* TA0CCR0/1000;
			if(Channel==2) TA0CCR2=Percent* TA0CCR0/1000;
			break;
		}
		case 3:		//ռձһΪҪ TA0CCR0ȥռձ
		{
			if(Percent>1000)	Percent=1000;
			if(Channel==1) TA0CCR1= TA0CCR0-Percent*TA0CCR0/1000;
			if(Channel==2) TA0CCR2= TA0CCR0-Percent*TA0CCR0/1000;
			break;
		}
		default: return(0);
		}
		return (1);
	}

/*************TA1*******************/

/******************************************************************************************************
*        ƣTA1_PWM_Init()
*        ܣTA1ʱΪPWMĳʼú
* ڲClk:ʱԴ 'S'=SMCLK;   'A'=ACLK ;   'E'=TACLK(ⲿ) 'e'= TACLK(TACLKȡ)
                    Div:ʱӷƵϵ: 1/2/4/8
		    Mode1:ͨ1ģʽ 'F'ΪǰPWMģʽ7'B'ͺPWMģʽ3 'D'PWMģʽ60=
		    Mode2:ͨ2ģʽ 'P'ΪǰPWMģʽ7'B'ͺPWM ģʽ3'D'PWMģʽ20=
		    ƵPWMʱͨʹãҾΪģʽ
* ڲ1ʾóɹ0ʾʧܡ
* ˵        : ڵPWMغ֮ǰҪøúTAģʽʱԴ
*         : TA1_PWM_Init('A',1,'P','P')TAʱΪACLK,ͨ1ͨ2ΪǰPWM
                   TA1_PWM_Init('S',4,'D','D')TAʱΪSMCLK/4, ͨ1ΪPWMͨ2ΪPWM
                   TA1_PWM_Init('A',1,'P',0)TAʱΪACLK,ͨ1ǰPWMͨ2TAá
 ******************************************************************************************************/
char TA1_PWM_Init(char Clk,char Div,char Mode1,char Mode2)
{
  TA1CTL =0;																// ǰ

  switch(Mode1)															//Ϊʱѡģʽ
  {
  case 'F': case 'f':														//ͨPWM
	  TA1CTL |=MC_1; break;										//ʱΪ
  case 'B':case 'b':
	  TA1CTL |=MC_1; break;										//ʱΪ
  case 'D': case 'd':														//PWM
      TA1CTL |=MC_3; break;										//ʱΪ
  default : return(0);													//ò󣬷0
  }

  switch(Clk)  																//ΪʱTAѡʱԴ
  {
    case 'A': case 'a':  	TA1CTL|=TASSEL_1; break;   			//ACLK
    case 'S': case 's': 	TA1CTL|=TASSEL_2; break;  			//SMCLK
    case 'E':            		TA1CTL|=TASSEL_0; break;  			//ⲿ(TACLK)
    case 'e':          			TA1CTL|=TASSEL_3; break;   			//ⲿ(TACLKȡ)
    default :  return(0);  														//ò󣬷0
  }
  switch(Div) 																		//ΪʱTAѡƵϵ
  {
    case 1:   TA1CTL|=ID_0; break;   //1
    case 2:   TA1CTL|=ID_1; break;   //2
    case 4:   TA1CTL|=ID_2; break;   //4
    case 8:   TA1CTL|=ID_3; break;   //8
    default :  return(0);  														//ò󣬷0
  }
  switch(Mode1)										 							//PWMͨ1ģʽ
  {
     case 'F':	case 'f':
              TA1CCTL1 =OUTMOD_7;
              TA11_SET;
              break;
     case 'B':	case 'b':
              TA1CCTL1 =OUTMOD_3;
              TA11_SET;
              break;
     case 'D': case'd':
	     TA1CCTL1 =OUTMOD_6;
    	     TA11_SET;
    	     break;
      case '0':case 0:   									//Ϊ
             TA11_OFF;   									//TA0.1ָΪͨIO
              break;
     default :  return(0); 							    //ò󣬷0
  }
  switch(Mode2) 										//PWMͨ2ģʽ
  {
      case 'F':	 case 'f':
              TA1CCTL2 =OUTMOD_7;
              TA12_SET;
       case 'B':	case 'b':
              TA1CCTL2 =OUTMOD_3;
              TA12_SET;
                break;
       case 'D': case 'd':
	       	   TA1CCTL2 =OUTMOD_2;
	       	   TA12_SET;
	       	   break;
       case '0':case 0:   									//Ϊ
           	 	TA12_OFF;   								//TA0.1ָΪͨIO
           	 	break;
       default :  return(0); 							//ò󣬷0
    }
  return(1);
}
/******************************************************************************************************
*        ƣTA1_PWM_SetPeriod()
*        ܣPWM
* ڲChannel: TA0=0, TA1=1
*                     Period:(0~65535) ʱӸ
* ڲ1óɹ     0ʧ
* ˵        : ͨPWMPWMһ
*         : TA1_PWM_SetPeriod(500)PWMΪ5001000ʱ
 ******************************************************************************************************/
char TA1_PWM_SetPeriod(unsigned int Period)
{
	if (Period>65535)	return(0);
	 TA1CCR0 = Period;
	return(1);
}

/******************************************************************************************************
*     ƣTA0_PWM_SetPermill()
*     ܣPWMռձ(ǧֱ)
* ڲChannel: ǰõͨ  1/2
            Duty: PWMߵƽЧʱǧֱ (0~1000)
* ڲ1óɹ0ʧ
* ˵    : 1000=100.0%  500=50.0% ơģʽʱchannelͬʱ趨
*     : TA_PWM_SetPermill(1,300)PWMͨ1ռձΪ30.0%
               TA_PWM_SetPermill(2,,825)PWMͨ2ռձΪ82.5%
 ******************************************************************************************************/
char TA1_PWM_SetPermill(char Channel,unsigned int Duty)
{
	unsigned char Mod;
	unsigned long int Percent=0;								//ֹ˷ʱ
	Percent=Duty;
	switch (Channel)													//жϳͨĹģʽ
		{
	case 1:
		Mod = (TA1CCTL1 & 0x00e0)>>5;		break;	//ȡģʽOUTMOD0λ5-7λ
	case 2:
		Mod = (TA1CCTL2 & 0x00e0)>>5;		break;	//ȡģʽOUTMOD1λ5-7λ
	default:	return(0);
		}

	switch(Mod)			//ģʽ趨TACCRx
		{
	case 2: case 6:			/**ģʽ2,6ʱҪжʱ䣬ͬʱ趨TA1CCR1/2 ֵ*/
		{
			if((1000-2*Percent)<=DEADTIME)	//Ԥʱ
				Percent=(1000-DEADTIME)/2;
			TA1CCR1=Percent* TA1CCR0/1000;
			TA1CCR2= TA1CCR0-TA1CCR1;
			break;
		}
		case 7:
		{
			if(Percent>1000)	Percent=1000;
			if(Channel==1) TA1CCR1=Percent* TA1CCR0/1000;
			if(Channel==2) TA1CCR2=Percent* TA1CCR0/1000;
			break;
		}
		case 3:		//ռձһΪҪ TA1CCR0ȥռձ
		{
			if(Percent>1000)	Percent=1000;
			if(Channel==1) TA1CCR1= TA1CCR0-Percent* TA1CCR0/1000;
			if(Channel==2) TA1CCR2= TA1CCR0-Percent* TA1CCR0/1000;
			break;
		}
		default: return(0);
		}
		return (1);
	}
